#----------------------------------------------------------------------------
#		     eggdrop 1.6.18/Suzi, tcl 8.5.2, freeBSD 7
#		    : anaesthesia #eggdrop@Rusnet
#----------------------------------------------------------------------------
package require Tcl 	8.4
package require http	2.5

namespace eval otvet {
foreach p [array names otvet *] { catch {unset otvet ($p) } }
#----------------------------------------------------------------------------
#    (Suzi / http.tcl)
#----------------------------------------------------------------------------
	variable unamespace		[namespace tail [namespace current]]
	variable author			"anaesthesia"
	variable version		"01.06"
	variable date			"24-jun-2008"

	#     (   )
	variable pubprefix 		{!}
	variable pubflag		{-|-}

	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:otvet		"$unamespace "

	#    ,   
	variable msgprefix		{!}
	variable msgflag		{-|-}
	#       
	variable msg:otvet		${pub:otvet}

	#      ,      
	#     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id 
	#  .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	2

	#     
	variable maxrequests	5

	#   ,       , 
	#  
	variable pause			35
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -
	#  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		""
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag			"$flagactas$unamespace"

	setudef  flag 			$chflag
	setudef  flag 			$chflag\q

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		1
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok			{  }

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}

	#   
	variable maxres		10

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	# ,     
	variable 		fetchurl		"http://search.otvet.mail.ru/"

	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---   ---

	proc tolow {strr} {
    	return [string tolower [string map {                                                                 } $strr]]
	}

	proc sspace {strr} {
  		return [string trim [regsub -all {[\t\s]+} $strr { }]]
	}

	proc msg:otvet { unick uhost handle str } {
		pub:otvet $unick $uhost $handle $unick $str
		return
	}

	proc pub:otvet { unick uhost handle uchan str } {
		variable pubprefix 
		variable requserid
		variable fetchurl
		variable ltype
		variable chflag
		variable flagactas
		variable errsend
		variable maxres
		variable pubsend
		variable msgsend
		variable unamespace
		variable mpage
		variable mstr

		set id [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]

		if {$unick ne $uchan} {
			if {![channel get $uchan $chflag] ^ $flagactas eq "no"} {return}
		}

		set why [queue_isfreefor $id]		
		if {$why != ""} {lput puthelp $why $prefix ; return}

#---

	if {[regexp -nocase -- {^-(\d+)} $str -> mpg]} {set mpage [expr ($mpg - 1)] ; regsub -- {-\d+\s+} $str "" str} {set mpage 0}
	set mstr [expr ($mpage / 10) * 10]
	if {$mstr == 0} {set sf ""} {set sf "&sf=$mstr"}
	set ustr [tolow $str]

		if {$ustr == ""} {
			if {$uchan eq $unick} {set prefix [subst -nocommands $errsend]} {set prefix [subst -nocommands $pubsend]}
			lput puthelp "\002\002: $pubprefix$unamespace \[+\]\[-\] <>  -  . \002:\002 $pubprefix$unamespace " $prefix		
			lput puthelp "\002\002: \002+\002 -  . \002:\002 $pubprefix$unamespace +" $prefix
			return
		} else {
			if {$uchan eq $unick} {set prefix [subst -nocommands $errsend]} {set prefix [subst -nocommands $errsend]}
				if {[regexp -nocase -- {\+} $ustr]} {
					regsub -- {\+} $ustr "" ustr
					set ltype "otv"
				} else {
					set ltype "norm"
				}
		}
			
		variable logrequests

		if {$logrequests ne ""} {
			set logstr [subst -nocommands $logrequests]
			variable unamespace
			lput putlog $logstr "$unamespace: "
		}

		::http::config -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	

		if {[queue_add "$fetchurl?zvstate=1&q=[uenc [string trim $ustr]]$sf" $id "[namespace current]::dream:parser" [list $unick $uhost $uchan {}]]} {
			variable err_ok
			if {$err_ok ne ""} {
				lput puthelp "$err_ok." $prefix
			}
		} else {
			variable err_fail
			if {$err_fail ne ""} {
				lput puthelp $err_fail $prefix
			}
		}
		return
	}
#---parser
	proc dream:parser { errid errstr body extra } {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_ok
		variable err_fail
		variable pubsend
		variable msgsend
		variable errsend
		variable useurl
		variable maxres
		variable mpage
		variable mstr
		variable ltype
		variable chflag
		variable flagactas

		foreach { unick uhost uchan ustr } $lextra { break }

		if {$lerrid ne {ok}} {
			lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]
			return
		}

		if {$uchan eq $unick} {
			set prefix [subst -nocommands $msgsend]
		} else {
			if {![channel get $uchan $chflag\q] ^ $flagactas eq "no"} {
				set prefix [subst -nocommands $pubsend]
			} else {
				set prefix [subst -nocommands $msgsend]
			}
		}
#--suzi-patch
	global sp_version
	if {[info exists sp_version]} {	
		set str [encoding convertfrom cp1251 $lbody] 
		} else {
		set str $lbody
		}
#----------------------------------------------------------------------------
##--parser-specific------
#----------------------------------------------------------------------------

	if {[string match "*     *" $str]} {
		lput putserv "\037  \037." $prefix
		return
	}

		if {[regexp -- {<div class="t70 tah grey mb10">.*?<b>(.*?)</b></div>} $str -> snumall]} {

				if {[regexp -- {<table class="Questions">(.*?)</table>} $str -> sdata]} {
					regsub -all -- "<b>|</b>" $sdata "\002" sdata
					regsub -all -- "\n|\r" $sdata "" sdata
					regsub -all -- "</tr>" $sdata "</tr>\n" sdata
						set sans [list]; set cnt 0; set aurl ""
						set r [expr ($mpage % 10)]
						foreach sline [split $sdata \n] {
							if {[regexp -nocase -- {<td class="num">(.*?)\.</td>.*?<div class="det"><a href="(.*?)" onclick.*?>(.*?)</a>.*?<a href=.*?>(.*?)</a>.*?<div class="black">(.*?)</div>} $sline -> snum surl shead scats desc]} {
								if {$cnt == $r} {set aurl $surl}	
							lappend sans [sconv [sspace "($snum/$snumall) \[$scats\] \00305$shead\003 :: $desc @ \037\00312$surl\003\037"]]
							incr cnt
							}
						}
				} else {
					putlog " "
				}
			if {$ltype eq "otv"} {
				queue_add $aurl $snum "[namespace current]::otvet:parser" [list $unick $uhost $uchan $sans]
			} else {
				if {$mpage <= $snumall} {
					lput putserv "[lindex $sans $r]" $prefix
				} else {
					lput putserv "\037  \037. ( : $snumall)" $prefix
				}
			}
	
		} else {
			lput putserv "\037 \037." $prefix
			return
		}

	return
	}		
#----------------------------------------------------------------------------
##--ok------
#----------------------------------------------------------------------------
	proc otvet:parser { errid errstr body extra } {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_fail
		variable pubsend
		variable msgsend
		variable errsend
		variable maxres
		variable mpage

		foreach { unick uhost uchan sans } $lextra { break }
		if { $lerrid ne {ok} } {lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]; return}
		set prefix [subst -nocommands $msgsend]
		global sp_version
		if {[info exists sp_version]} {set str [encoding convertfrom cp1251 $lbody]} {set str $lbody}

#--otvet-parser
		if {[regexp -- {<table><tr><td><div class="mt15 mb15 t120">(.*?)</div></td></tr></table>} $str -> sotv]} {
			regsub -all -- "<br><br>" $sotv "\n" sotv
			regsub -all -- "<.*?>" $sotv "" sotv
				lput putserv "[lindex $sans [expr $mpage - 1]]" $prefix
				foreach sline [split $sotv \n] {
					lput putserv "$sline" $prefix
				}
		} else {
		putlog "parse error"
		}
	return
	}	

#---output
	proc lput { cmd str { prefix {} } {maxchunk 420} } {

	set buf1 ""; set buf2 [list];

		foreach word [split $str] {
		append buf1 " " $word;
			if {[string length $buf1]-1 >= $maxchunk} {
			lappend buf2 [string range $buf1 1 end];
			set buf1 "";
			}
		}
		if {$buf1 != ""} {
		lappend buf2 [string range $buf1 1 end];
		}
	foreach line $buf2 {		
		$cmd $prefix$line 
	}
		return
	}

#---  
	proc sconv {text} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	};
	set text [string map $escapes [join [lrange [split $text] 0 end]]]; 
    regsub -all -- {\[} $text "\\\[" text
    regsub -all -- {\]} $text "\\\]" text
    regsub -all -- {\(} $text "\\\(" text
    regsub -all -- {\)} $text "\\\)" text
  	regsub -all -- {&#([[:digit:]]{1,5});} $text {[format %c [string trimleft "\1" "0"]]} text
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $text {[format %c [scan "\1" %x]]} text
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $text "" text
	return [subst -novariables $text]
	}

#--- url
	proc uenc {strr} {
	set str ""
		foreach byte [split [encoding convertto cp1251 $strr] ""] {
        scan $byte %c i
        	if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {
				append str [format %%%02X $i]
        	} else {
				append str $byte
        	}
		}
	return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
    }

#---queue
	proc queue_isfreefor { { id {} } } {

		variable reqqueue
		variable maxreqperuser
		variable maxrequests
		variable laststamp
		variable pause

		variable err_queue_full	
		variable err_queue_id
		variable err_queue_time 

		if {[info exists laststamp(stamp,$id)]} {
			set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}]

			if {$timewait > 0} {
				return [subst -nocommands $err_queue_time]
			}			
		}

		if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {
			return $err_queue_id
		}

		if {[llength [array names reqqueue]] >= $maxrequests} { 
			return $err_queue_full
		}
		
		return
	}

#---add-to-queue
	proc queue_add { newurl id parser extra {redir 0} } {
		variable reqqueue
		variable proxy
		variable timeout
		variable laststamp

		::http::config -proxyfilter "[namespace current]::queue_proxy"
		
		if {![catch {set token [::http::geturl $newurl -command "[namespace current]::queue_done" -binary true -timeout $timeout]} errid]} {		
			set reqqueue($token,$id) [list $parser $extra $redir]		
			set laststamp(stamp,$id) [unixtime]
		} else {
			return false
		}
		return true
	}

#---proxy
	proc queue_proxy { url } {
		variable proxy
		if {$proxy ne {}} {return [split $proxy {:}]}		
		return [list]
	}
	
#---callback
	proc queue_done { token } {
		upvar #0 $token state
		variable reqqueue
		variable maxredir
		
		set errid  		[::http::status $token]
		set errstr 		[::http::error  $token]
		
		set	id  	[array  names reqqueue "$token,*"]
		foreach { parser extra redir } $reqqueue($id) {break}
		regsub -- "^$token," $id {} id
	
		while (1) {
			if {$errid == "ok" && [::http::ncode $token] == 302} {
				if {$redir < $maxredir} {			
					array set meta $state(meta)
					if {[info exists meta(Location)]} {
						variable fetchurl
						queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]
						break
					}
				} else {
					set errid   "error"
					set errstr  "Maximum redirects reached."
				}
			} 
			if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {
				lput putlog $errid "[namespace current] "
			}
			break
		}
			
		array unset reqqueue "$token,*"
		::http::cleanup $token
		return
	}

#---clear
	proc queue_clear_stamps {} {

		variable laststamp
		variable timeout
		variable timerID

		set curr [expr {[unixtime] - 2 * $timeout / 1000 }];

		foreach {id} [array names laststamp] {
			if {$laststamp($id) < $curr} {
				array unset laststamp $id;
			}
		}		

		set timerID [timer 10 "[info level 0]"]
	}

#---command aliases & bnd
	proc cmdaliases { { action {bind} } } {
		foreach {bindtype} {pub msg dcc} {
			foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix"
				variable "${bindtype}flag"			
				foreach {alias} [set $bindproc] {
					catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}
				}				
			}
		}	
		return
	}
#---killtimers	
	if {[info exists timerID]} {
		catch {killtimer $timerID}; 
		catch {unset timerID}
	}
#---rest	
	[namespace current]::queue_clear_stamps
	cmdaliases
	global sp_version
	if {[info exists sp_version]} {
	putlog "[namespace current] v$version suzi_$sp_version \[$date\] by $author loaded."
	} else {
	putlog "[namespace current] v$version \[$date\] by $author loaded."
	}
}










